strings = {}
strings['de'] = {
    'What to do ?': 'Was ist zu tun ?',
    'Start cabin heating': 'Starte die Heizung',
    'Flash lights': 'Lichthupe',
    'Make some noise': 'Mach Lärm !',
    'Lock the doors': 'Türen verriegeln',
    'Nothing, thank you.': 'Nix, danke.',
    'head the cabin': 'den Innenraum heizen',
    'flash the lights': 'die Lichter anmachen',
    'blow the horn': 'die Hupe betätigen',
    'lock the doors': 'die Türen verriegeln',
    'You want to ': 'Du möchtest ',
    'Just to make it clear': 'Nur um sicherzugehen',
    'Yes dude !': 'Ja Man !',
    'Noooooooo !': 'Neiiiiiiin',
    'Its done': 'Erledigt',
    'Your request to ': 'Deine Anforderung für ',
    ' was sent.': ' wurde gesendet.',
    'Thank you !': 'Dankeschön ;o)',
    'Unable to login': 'Login nicht möglich',
    'You want to enter your credentials again ?': 'Möchtest Du Deine Zugangsdaten noch mal eintragen?',
    'Yes': 'Ja',
    'No, they are fine': 'Nein, die sind ok',
    'Save': 'Speichern'
};

const userKey = Script.name() + '_cd_user';
const passKey = Script.name() + '_cd_pass';
const vinKey = Script.name() + '_vin';
const bigFontSize = 13;
const smallFontSize = 11;
const smallIconSize = new Size(15, 50);
const bigIconSize = new Size(20, 20);
const smallCarSize = new Size(150, 150);
const bigCarSize = new Size(160, 160);

const startColor = new Color(rgbToHex(69, 75, 109));

let ENDPOINT_DATAFETCH = 'https://b2vapi.bmwgroup.com/api/vehicle/dynamic/v1/';
let ENDPOINT_VINFETCH = 'https://b2vapi.bmwgroup.com/api/me/vehicles/v2?all=true&brand=BM';
let ENDPOINT_CHARGEFETCH = 'https://cocoapi.bmwgroup.com/eadrax-chs/v1/charging-sessions';


/* set clean to true to clear the image cache */

const clean = false;

/* do not touch this flag */
const dev = false;

if ((Keychain.contains(userKey)) && Keychain.contains(passKey)) {

    let carData = await accumulateData();
    const mainWdgData = await createWidget(carData); // build the normal widget login get the token vin and data
    const widget = mainWdgData;
    const token = carData.token; // we need the token and vin for later actions
    const vin = carData.vin;

    if (config.runsInWidget) {
        Script.setWidget(widget);
    } else {
        widget.presentMedium();
        return; // currently there are no remote functions possible .. 
        let useralert = new Alert();
        useralert.title = localize('What to do ?');
        useralert.addAction(localize('Start cabin heating'));
        useralert.addAction(localize('Flash lights'));
        useralert.addAction(localize('Make some noise'));
        useralert.addAction(localize('Lock the doors'));
        useralert.addCancelAction(localize('Nothing, thank you.'));
        let action = await useralert.present();
        switch (action) {
            case 0:
                proceedAction('head the cabin', 'RCN', token, vin);
                break;
            case 1:
                proceedAction('flash the lights', 'RLF', token, vin);
                break;
            case 2:
                proceedAction('blow the horn', 'RHB', token, vin);
                break;
            case 3:
                proceedAction('lock the doors', 'RDL', token, vin);
                break;
        }
    }
    Script.complete();
} else {
    await askForUsername();
    await askForPassword();
}

function getPostBody(input) {
    let result = '';
    Object.keys(input).map((key) => {
        result = result + '&' + key + '=' + encodeURIComponent(input[key]);
    })
    return result;
}

function localize(text) {
    let lng = Device.language();
    if ((strings[lng]) && (strings[lng][text])) {
        return strings[lng][text];
    } else {
        return text;
    }
}

async function accumulateData() {
    let result = {};
    let vin;
    let token = await getLoginToken();
    if (token) {
        result.token = token;
        vin = getVinbyParameterOrKeyChain();
        if (vin === false) {
            vin = await getVin(token);
        }
        if (vin) {
            result.vin = vin;
            result.carImage = await fetchImage(vin);
            let data = await getVehicleStatus(token, vin);
            if (data) {
                result.charging_status = data.charging_status;
                result.chargingSystemStatus = data.chargingSystemStatus;
                result.chargingTimeRemaining = data.chargingTimeRemaining;
                result.chargingLevelHv = data.chargingLevelHv;
                result.battery_size_max = data.battery_size_max;
                result.beRemainingRangeElectricKm = data.beRemainingRangeElectricKm;
                result.door_lock_state = data.door_lock_state;
                result.updateTime = data.updateTime;
                result.lat = data.gps_lat;
                result.lon = data.gps_lng;
                let nowDate = new Date();
                let chg = await getlastCharge(token, vin, nowDate);
                if (chg.latest === undefined) {
                    // maybe we have a new month and the uses hasnt chargd yet so go one month back
                    nowDate.setDate(1);
                    let month = nowDate.getMonth();
                    if (month === 0) { // Special in january go also one year back
                        nowDate.setMonth(11); // 
                        nowDate.setFullYear(nowDate.getFullYear() - 1);
                    } else {
                        nowDate.setMonth(nowDate.getMonth() - 1);
                    }
                    chg = await getlastCharge(token, vin, nowDate);
                }
                result.lastCharge = chg.latest;

            } else {
                result.error = 'unable to fetch data';
            }
        } else {
            result.error = 'unable to get your vin';
        }
    } else {
        result.loginError = true;
        result.error = 'unable to login';
    }
    return result;
}

async function createWidget(data) {
    let bgColorStr = '#FFFFFF';
    let fgColorStr = '#000000';

    if (Device.isUsingDarkAppearance()) {
        bgColorStr = '#000000';
        fgColorStr = '#FFFFFF';
    }
    let chrglblCol = new Color(fgColorStr);
    const fgColor = new Color(fgColorStr);
    const bgColor = new Color(bgColorStr);
    const bigFont = Font.systemFont(bigFontSize);
    const smallFont = Font.systemFont(smallFontSize);

    const widget = new ListWidget();
    let canvas;

    if (data.error === undefined) {

        if (startColor !== undefined) {
            console.log('Adding Gradient');
            const gradient = new LinearGradient();
            gradient.colors = [startColor, bgColor];
            gradient.locations = [0.0, 1];
            widget.backgroundGradient = gradient;
        } else {
            widget.backgroundColor = bgColor;
        }
        let carIconCell;
        let wideMode = false;
        if ((config.widgetFamily === 'medium') || (config.widgetFamily === 'large') || (config.runsInWidget === false)) {
            let row = widget.addStack();
            row.layoutHorizontally();
            canvas = row.addStack();
            canvas.layoutVertically();
            row.addSpacer(8);
            carIconCell = row.addStack();
            wideMode = true;
        } else {
            canvas = widget;
        }

        const firstLine = canvas.addStack();
        firstLine.layoutHorizontally();

        // Battery stack
        const batteryStack = firstLine.addStack();
        // Battery icon
        let batIconName = 'battery.0';
        let batColor = new Color('#ff0000');

        if (data.chargingLevelHv > 25) { batIconName = 'battery.25'; batColor = new Color('#f7821b'); }
        if (data.chargingLevelHv > 50) { batIconName = 'battery.50'; batColor = new Color('#dcf921'); }
        if (data.chargingLevelHv > 75) { batIconName = 'battery.75'; batColor = new Color('#2cf921'); }
        if (data.chargingLevelHv > 75) { batIconName = 'battery.100'; batColor = new Color('#2cf921'); }

        const battIcon = SFSymbol.named(batIconName);
        const battIconElement = batteryStack.addImage(battIcon.image);
        battIconElement.imageSize = bigIconSize;
        batteryStack.addSpacer(8);

        // Set color based on charging state
        if (data.charging_status == 'NOCHARGING') {
            battIconElement.tintColor = batColor;
        } else {
            chrglblCol = Color.blue();
            battIconElement.tintColor = chrglblCol;
        }
        // In small Mode remove the SOC (just show the km)
        const batteryText = batteryStack.addText((wideMode === true) ?
            `${Math.floor(data.chargingLevelHv)} % / ${Math.floor(data.beRemainingRangeElectricKm)} km` :
            `${Math.floor(data.beRemainingRangeElectricKm)} km`);

        batteryText.textColor = fgColor;
        batteryText.font = bigFont;

        firstLine.addSpacer();
        //DOOR LOCK ICON on the right
        let lockIcon;
        if (data.door_lock_state === 'SECURED') {
            lockIcon = SFSymbol.named('lock.fill');
        } else {
            lockIcon = SFSymbol.named('lock.open.fill');
        }
        let lockIconElement = firstLine.addImage(lockIcon.image);
        lockIconElement.rightAlignImage();
        lockIconElement.tintColor = new Color('#787878');
        lockIconElement.imageSize = bigIconSize;

        if (wideMode === true) { // Max Soc only in the wide Widget

            // MacSoc stack
            const maxSocStack = canvas.addStack();
            const maxSocIcon = SFSymbol.named('gauge.badge.plus');
            const maxSocIconElement = maxSocStack.addImage(maxSocIcon.image);
            maxSocIconElement.tintColor = fgColor;
            maxSocIconElement.imageSize = bigIconSize;
            maxSocStack.addSpacer(8);
            const maxSocText = maxSocStack.addText(`${data.battery_size_max} kWh`);
            maxSocText.textColor = fgColor;
            maxSocText.font = bigFont;
            canvas.addSpacer();

        }

        // in wide Mode we will add the iamge on the right side
        let carIconStack;
        let imgSize;
        let paddingTop = -45;
        let paddingLeft = -10;
        let paddingBottom = -25;
        let paddingTrailing = -20;
        if (wideMode === true) {
            imgSize = bigCarSize;
            paddingTop = -50;
            paddingBottom = -30;
            paddingTrailing = -30;
            paddingLeft = -20;
            carIconStack = carIconCell.addStack();
        } else {
            imgSize = smallCarSize;
            carIconStack = canvas.addStack();
        }


        const carImageStack = carIconStack.addStack();
        carIconStack.layoutHorizontally();
        carImageStack.backgroundColor = bgColor;
        carImageStack.cornerRadius = 8;
        const wimg = carIconStack.addImage(data.carImage);
        wimg.imageSize = imgSize;
        wimg.rightAlignImage();
        wimg.url = `https://maps.apple.com/?q=i3&ll=${data.lat},${data.lon}`;
        carIconStack.setPadding(paddingTop, paddingLeft, paddingBottom, paddingTrailing);
        canvas.addSpacer();




        // add the charging data if we are running in a wider mode
        if (wideMode === true) {
            if (data.lastCharge !== undefined) {
                let chargeStack = widget.addStack();
                let lchargeIcon = SFSymbol.named('bolt.car');
                let lchargeIconElement = chargeStack.addImage(lchargeIcon.image);
                lchargeIconElement.imageSize = bigIconSize;
                lchargeIconElement.tintColor = fgColor;
                chargeStack.addSpacer(8);

                let chargeText = chargeStack.addText(data.lastCharge);
                chargeText.font = bigFont;
                chargeText.textColor = fgColor;
                widget.addSpacer();
            }
        }

        // update stack
        let updateStack = widget.addStack();
        let chargingActive = (data.charging_status === 'CHARGINGACTIVE');
        let timeIcon = SFSymbol.named((chargingActive === true) ? 'timer' : 'clock');
        let timeIconElement = updateStack.addImage(timeIcon.image);
        timeIconElement.imageSize = bigIconSize;
        timeIconElement.tintColor = chrglblCol;
        updateStack.addSpacer(8);


        // Use the utc and convert to local time
        let df = new DateFormatter();
        let date;

        if (chargingActive === true) {
            console.log('Charging', data.chargingTimeRemaining)
            let now = new Date(); // calculate the charging end time based on the remaining minutes
            date = new Date(now.getTime() + parseInt(data.chargingTimeRemaining) * 60000);
        } else {
            df.dateFormat = 'dd.MM.yyyy HH:mm:ss Z';
            date = df.date(data.updateTime);
        }

        df.useShortDateStyle();
        df.useShortTimeStyle();
        console.log(date);
        let updateText = updateStack.addText(df.string(date));

        updateText.textColor = fgColor;

        if (wideMode === false) { // in smallmode make the text even smaller
            updateText.font = smallFont;
        } else {
            updateText.font = bigFont;
        }
        widget.addSpacer();


    } else {
        canvas = widget;
        canvas.addText(data.error);
        if ((data.loginError === true) && (config.runsInWidget === false)) {
            showReloginAlert();
        }
    }
    return widget
}

async function proceedAction(question, actionType, token, vin) {
    let proceedAlert = new Alert();
    proceedAlert.title = localize('Just to make it clear');
    proceedAlert.message = localize('You want to ') + localize(question) + '?';
    proceedAlert.addAction(localize('Yes dude !'));
    proceedAlert.addCancelAction(localize('Noooooooo !'));
    let action = await proceedAlert.present();
    if (action === 0) {
        await performRemoteAction(actionType, token, vin);
        proceedAlert = new Alert();
        proceedAlert.title = localize('Its done');
        proceedAlert.message = localize('Your request to ') + localize(question) + localize(' was sent.');
        proceedAlert.addAction(localize('Thank you !'));
        await proceedAlert.present();
    }
}

async function showReloginAlert() {
    let useralert = new Alert();
    useralert.title = localize('Unable to login');
    useralert.message = localize('You want to enter your credentials again ?');
    useralert.addAction(localize('Yes'));
    useralert.addCancelAction(localize('No, they are fine'));
    let action = await useralert.present();
    if (action === 0) {
        await askForUsername();
        await askForPassword();
    }
}

async function askForUsername() {
    let useralert = new Alert();
    useralert.title = 'Connected Drive';
    let cduser = useralert.addTextField('Username');
    useralert.addAction(localize('Save'));
    await useralert.present();
    Keychain.set(userKey, useralert.textFieldValue(0));
}

async function askForPassword() {
    let useralert = new Alert();
    useralert.title = 'Connected Drive';
    let cduser = useralert.addSecureTextField('Password');
    useralert.addAction(localize('Save'));
    await useralert.present();
    Keychain.set(passKey, useralert.textFieldValue(0));
}

function componentToHex(c) {
    var hex = c.toString(16);
    return hex.length == 1 ? "0" + hex : hex;
}

function rgbToHex(r, g, b) {
    return "#" + componentToHex(r) + componentToHex(g) + componentToHex(b);
}

function getVehicleImage(vin) {
    return new Promise(async (resolve, reject) => {
        let vehicleImageListUrl = `https://b2vapi.bmwgroup.com/api/vehicle/image/v1/${vin}?startAngle=0&stepAngle=10&width=780`;
        let vehicleImageListRequest = new Request(vehicleImageListUrl);
        vehicleImageListRequest.method = 'get';
        vehicleImageListRequest.headers = { 'Content-Type': 'application/json' };
        vehicleImageListRequest.timeoutInterval = 10;
        vehicleImageListRequest.loadJSON().then(data => {
            if ((data) && (data.angleUrls)) {
                resolve(data.angleUrls[4].url);
            } else {
                resolve(false);
            }
        }).catch(e => {
            resolve(false);
        })
    })
}


function performRemoteAction(action, token, vin) {
    return new Promise(async (resolve, reject) => {
        let remoteCommandUrl = 'https://www.bmw-connecteddrive.com/remoteservices/rsapi/v1/' + vin + '/' + action;

        let remoteRequest = new Request(remoteCommandUrl);
        remoteRequest.body = '{}';
        remoteRequest.method = 'POST';
        remoteRequest.headers = {
            'Authorization': 'Bearer ' + token,
            'Content-Type': 'application/json'
        }
        remoteRequest.loadJSON().then((data) => {
            resolve();
        })
            .catch((e) => {
                console.error(e);
                resolve();
            })

    })
}

function getVehicleStatus(token, vin) {
    console.log("getVehicleStatus");
    return new Promise(async (resolve, reject) => {
        const dt = new Date().getTime();
        let vehicleDataUrl = `${ENDPOINT_DATAFETCH}${vin}`;
        let vehicleDataRequest = new Request(vehicleDataUrl);
        vehicleDataRequest.method = 'get';
        vehicleDataRequest.headers = {
            'Authorization': 'Bearer ' + token,
            'Content-Type': 'application/json'
        }
        console.log(vehicleDataUrl);
        let data = await vehicleDataRequest.loadJSON();
        if (data) {
            console.log('Success try to find your vin');
            console.log(data.attributesMap);
            resolve(data.attributesMap);
        } else {
            console.log(data);
            resolve(false);
        }
    })
}

function getVinbyParameterOrKeyChain() {
    let parameters = args.widgetParameter;
    if (parameters != null && parameters.length > 0) {
        console.log('using vin ' + parameters + ' from widget parameters');
        return parameters;
    } else {
        // try the keychain
        if (!Keychain.contains(vinKey)) {
            console.log('there is no stored vin');
            return false;
        } else {
            let vin = Keychain.get(vinKey);
            console.log('using vin ' + vin + ' from keychain');
            return vin;
        }
    }
}

function getVin(token) {
    console.log("vin request")
    return new Promise(async (resolve, reject) => {
        console.log('using vin from cd');
        let vehicleListUrl = ENDPOINT_VINFETCH;
        let vehicleListRequest = new Request(vehicleListUrl);
        vehicleListRequest.method = 'get';
        vehicleListRequest.headers = {
            'Authorization': 'Bearer ' + token,
            'Content-Type': 'application/json'
        }
        console.log(vehicleListUrl);
        let list = await vehicleListRequest.loadJSON();
        console.log(list);
        if (list.length > 0) {
            let vin = list[0].vin;
            console.log(list[0]);
            Keychain.set(vinKey, vin);
            resolve(vin);
        } else {
            console.log(list[0]);
            resolve(false);
        }
    })
}

function getlastCharge(token, vin, date) {
    let result = {}
    result.latest = undefined
    return new Promise(async (resolve, reject) => {
        let df = new DateFormatter();
        df.dateFormat = 'yyyy-MM';
        let thisMonth = df.string(date) + '-01T00:00:00.000';
        let chargeSessionUrl = `${ENDPOINT_CHARGEFETCH}?include_date_picker=false&maxResults=40&vin=${vin}&date=${thisMonth}`
        let vehicleChargeRequest = new Request(chargeSessionUrl);
        vehicleChargeRequest.method = 'get';
        vehicleChargeRequest.headers = {
            'Authorization': 'Bearer ' + token,
            'Content-Type': 'application/json'
        }
        let list = await vehicleChargeRequest.loadJSON();
        if (list.chargingSessions !== undefined) {
            result.nrj = list.chargingSessions.total;

            if ((list.chargingSessions.sessions) && (list.chargingSessions.sessions.length > 0)) {
                let latest = list.chargingSessions.sessions[0];
                result.latest = `${latest.title} | ${latest.energyCharged}`;
            }
        }
        resolve(result)
    })
}

async function getLoginToken() {
    let user;
    let pwd;

    if (dev === true) {
        return '12345';
    }

    try {
        if (!Keychain.contains(userKey)) {
            console.error('missing parameters');
        } else {
            user = Keychain.get(userKey);
            pwd = Keychain.get(passKey);
        }
        let url = 'https://customer.bmwgroup.com/gcdm/oauth/authenticate';
        let post_data = {
            'state': 'eyJtYXJrZXQiOiJkZSIsImxhbmd1YWdlIjoiZGUiLCJkZXN0aW5hdGlvbiI6ImxhbmRpbmdQYWdlIn0',
            'username': user,
            'client_id': 'dbf0a542-ebd1-4ff0-a9a7-55172fbfce35',
            'password': pwd,
            'redirect_uri': 'https://www.bmw-connecteddrive.com/app/default/static/external-dispatch.html',
            'response_type': 'token',
            'scope': 'authenticate_user fupo',
            'locale': 'DE-de'
        };
        let lRequest = new Request(url);
        lRequest.method = 'POST';
        lRequest.body = getPostBody(post_data);
        let result = await lRequest.load();
        console.log(lRequest.response.url);
        let tokenUrl = lRequest.response.url
        if (tokenUrl) {
            let match = tokenUrl.match(/&access_token=([a-zA-z0-9]{0,})/);
            if (match != null) {
                let token = match[1];
                console.log("token found %s", token);
                return token;
            }
        } else {
            console.error("missing token");
        }

    } catch (e) {
        console.error(e);
    }
    return null;
}

function clearImageCache(vin) {
    let fm = FileManager.local();
    let dir = fm.documentsDirectory();
    let path = fm.joinPath(dir, vin + '.png');
    if (fm.fileExists(path)) {
        fm.remove(path);
    }
}

//this will fetch the car image
// if there is an error we will use the default image from bwm sales
function fetchImage(vin) {

    if (clean === true) {
        clearImageCache(vin);
    }

    return new Promise(async (resolve, reject) => {
        let fm = FileManager.local();
        let dir = fm.documentsDirectory();
        let path = fm.joinPath(dir, vin + '.png');
        if (fm.fileExists(path)) {
            resolve(fm.readImage(path));
        } else {
            const dummyURL = 'https://prod.cosy.bmw.cloud/bmwweb/cosySec?COSY-EU-100-7331cqgv2Z7d%25i02uCaY3MuO2kOHUtWPfbYfGKDl10tLhu1XzWVo7puMLWFmdkAj5DOPHxV%25Z8XgY1nTNIowJ4HO3zkyXq%25sGM8snGhMQSk%2508Xc9Vo74giUSNF1VgxNJ0%25ls2oub5imC2yRCzXeTt%25ViPRKVZVYpnaWh1DMztIi8eqVYDaf4RLjmztYRSFX767aftxd9Xgw1RSfWQoeD%25VxdSeZLdYuzWQdjcyBa3aeZQ6KdIrXRjcZwB6Jdrx6Kc%252wwN4WsKokGpc1Q8CBfJdoSWZ35uMwjhL';
            let carImageUrl = await getVehicleImage(vin);
            if (carImageUrl === false) {
                console.log('Using Dummy Image');
                carImageUrl = dummyURL;
            }
            let carImageRequest = new Request(carImageUrl);
            carImageRequest.loadImage().then(carImage => {
                console.log('Using real car image');
                fm.writeImage(path, carImage);
                resolve(carImage);
            }).catch(e => {
                resolve(undefined);
            })
        }
    })
}
